# How to contribute to PMD

First off, thanks for taking the time to contribute!

Detailed contributor info can be found in our documentation on <https://docs.pmd-code.org/latest/pmd_devdocs_contributing.html>.

**Pull Requests** are welcome. Create them against the `main` branch.

**Building:** Make sure, you can build PMD locally. You need Java 11+, then run `./mvnw clean verify`.
Guides for using various IDEs are available at <https://docs.pmd-code.org/latest/pmd_devdocs_building_general.html>.

**Code of Conduct:** <https://github.com/pmd/pmd/blob/main/code_of_conduct.md>

**Bug Reports / Features:** We use the issue tracker on GitHub. Please report new bugs and feature requests at <https://github.com/pmd/pmd/issues>.

**Reporting Security Issues:** <https://github.com/pmd/pmd/security/advisories/new>

**Main Documentation:** <https://docs.pmd-code.org/latest>

**Questions:**
There are various channels, on which you can ask questions:

*   On [StackOverflow](https://stackoverflow.com/questions/tagged/pmd): Make sure, to tag your question with "pmd".

*   Create a new discussion for your question at <https://github.com/pmd/pmd/discussions>.

*   Ask your question in our [Gitter room](https://app.gitter.im/#/room/#pmd_pmd:gitter.im).

*   Ask your question our [PMD Guru at Gurubase](https://gurubase.io/g/pmd).
